'use strict';
const flow = require('lodash.flow');
const path = require('path');
const values = require('object.values');
module.exports = function (context) {
    const uniquePaths = context.keys().reduce((obj, key) => {
        const existingKey = obj[context.resolve(key)];
        if (existingKey && existingKey.length <= key.length) {
            return obj;
        }
        return Object.assign({}, obj, {
            [context.resolve(key)]: key
        })
    }, {});
    const moduleMap = values(uniquePaths).reduce((obj, key) => Object.assign({}, obj, {
        [path.relative('.', key)]: context(key)
    }), {});
    let wrappersList = ['redux', 'relay'];
    if (moduleMap.index && moduleMap.index.wrappers) {
        wrappersList = moduleMap.index.wrappers
    }
    wrappersList = wrappersList.filter(moduleName => moduleMap[moduleName]);
    return Object.assign({}, moduleMap,
        {
            complete: wrappersList.reduce(
                (complete, moduleName) => flow(moduleMap[moduleName], complete),
                moduleMap.component
            )
        },
        wrappersList.reduce((obj, moduleName) => Object.assign({}, obj, {
            [`${moduleName}_wrapped`]: moduleMap[moduleName](moduleMap.component)
        }), {})
    );
};
